﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UnpinnedTabItem
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            MyTree.ItemsSource = Class1.TreeView;
        }
    }

    public class Class1 : INotifyPropertyChanged
    {
        private static ObservableCollection<Category> CreateCategories()
        {
            return new ObservableCollection<Category>
            {
                new Category
                {
                    CategoryID = 1,
                    CategoryName = "one",
                },

                new Category
                {
                    CategoryID = 2,
                    CategoryName = "two",
                },

                  new Category
                {
                    CategoryID = 3,
                    CategoryName = "three",
                },
            };
        }
        private static ObservableCollection<Product> CreateProducts()
        {
            return new ObservableCollection<Product>
            {
                new Product
                {
                    ProductID = 1,
                    ProductName = "product one",

                },

                new Product
                {
                    ProductID = 2,
                    ProductName = "product two",

                },

                new Product
                {
                    ProductID = 3,
                    ProductName = "product three",

                },

            };
        }

        private static ObservableCollection<Item> CreateItems()
        {
            return new ObservableCollection<Item>
            {
                new Item
                {
                    ItemID = 1,
                    ItemName = "item 1 ",

                },

                new Item
                {
                    ItemID = 2,
                    ItemName = "item 2",

                },

                 new Item
                {
                    ItemID = 3,
                    ItemName = "item 3",

                },

            };
        }
        public static ObservableCollection<Category> CreateTreeView()
        {
            ObservableCollection<Category> categories = Categories;
            ObservableCollection<Product> products = Products;
            ObservableCollection<Item> items = Items;
            Category parentCategory = null;
            Product parentProduct = null;

            foreach (var cat in categories)
            {
                foreach (var pro in products)
                {
                    if (cat.CategoryID == pro.ProductID)
                        cat.Products.Add(pro);
                    foreach (var item in items)
                    {
                        if (pro.ProductID == item.ItemID)
                            pro.ChildItems.Add(item);
                    }
                }
            }

            return categories;
        }
        private static ObservableCollection<Category> _treeView;
        public static ObservableCollection<Category> TreeView
        {
            get
            {
                if (_treeView == null)
                    _treeView = CreateTreeView();
                return _treeView;
            }

        }

        private static ObservableCollection<Category> _categories;
        public static ObservableCollection<Category> Categories
        {
            get
            {
                if (_categories == null)
                    _categories = CreateCategories();
                return _categories;
            }

        }

        private static ObservableCollection<Product> products;
        public static ObservableCollection<Product> Products
        {
            get
            {
                if (products == null)
                    products = CreateProducts();

                return products;
            }
        }

        private static ObservableCollection<Item> items;
        public static ObservableCollection<Item> Items
        {
            get
            {
                if (items == null)
                    items = CreateItems();

                return items;
            }
        }

        public class Category : INotifyPropertyChanged
        {
            #region private fields

            private int categoryID;
            private string categoryName;
            private ObservableCollection<Product> products;

            #endregion

            #region public properties
            public int CategoryID
            {
                get
                {
                    return categoryID;
                }
                set
                {
                    if (categoryID != value)
                    {
                        categoryID = value;
                        OnPropertyChanged("CategoryID");
                    }
                }
            }

            public string CategoryName
            {
                get
                {
                    return categoryName;
                }
                set
                {
                    if (categoryName != value)
                    {
                        categoryName = value;
                        OnPropertyChanged("CategoryName");
                    }
                }
            }

            public ObservableCollection<Product> Products
            {
                get
                {
                    if (products == null)
                    {
                        products = new ObservableCollection<Product>();
                    }

                    return products;
                }
            }
            #endregion

            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;

            protected virtual void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }
            #endregion
        }
        public class Product : INotifyPropertyChanged
        {

            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;

            protected virtual void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }
            #endregion

            #region private members

            private int productID;
            private string productName;
            private ObservableCollection<Item> childItems;
            #endregion

            #region public properties

            public int ProductID
            {
                get
                {
                    return productID;
                }
                set
                {
                    if (productID != value)
                    {
                        productID = value;
                        OnPropertyChanged("ProductID");
                    }
                }
            }

            public string ProductName
            {
                get
                {
                    return productName;
                }
                set
                {
                    if (productName != value)
                    {
                        productName = value;
                        OnPropertyChanged("ProductName");
                    }
                }
            }


            public ObservableCollection<Item> ChildItems
            {
                get
                {
                    if (childItems == null)
                    {
                        childItems = new ObservableCollection<Item>();
                    }

                    return childItems;
                }
            }

            #endregion
        }
        public class Item : INotifyPropertyChanged
        {

            #region INotifyPropertyChanged Members

            public event PropertyChangedEventHandler PropertyChanged;

            protected virtual void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }
            #endregion

            #region private members

            private int itemID;
            private string itemName;

            #endregion

            #region public properties

            public int ItemID
            {
                get
                {
                    return itemID;
                }
                set
                {
                    if (itemID != value)
                    {
                        itemID = value;
                        OnPropertyChanged("ItemID");
                    }
                }
            }

            public string ItemName
            {
                get
                {
                    return itemName;
                }
                set
                {
                    if (itemName != value)
                    {
                        itemName = value;
                        OnPropertyChanged("ItemName");
                    }
                }
            }



            #endregion
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(string p)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(p));
            }
        }
    }
}
